#ifndef APPUTIL_H
#define APPUTIL_H

#include "plogmsg.h"
#include "gatcp.h"
#include "filelock.h"

#ifdef	__cplusplus
extern "C" {
#endif

#define FILEARCH_REGISTRY_CFG	"/var/adm/amx/cfg/filearch.cfg"
#define AMXVIEWER_REGISTRY_CFG	"/var/adm/amx/cfg/amxviewer.cfg"
#define INDEXER_REGISTRY_CFG	"/var/adm/amx/cfg/indexer.cfg"
#define SCROLLER_REGISTRY_CFG	"/var/adm/amx/cfg/scroller.cfg"
#define WEBSITE_REGISTRY_CFG	"/var/adm/amx/cfg/website.cfg"

typedef enum {
    READ_CFG_FOUND = 0,
    READ_CFG_NOTFOUND,
    READ_CFG_NOFILE,
    READ_CFG_FAILURE
} READ_CFG_STS;

#define APP_ERROR 100	/* For non-successful exit status */

#define FALSE 0
#define TRUE 1

/* Used for signal handling. */
typedef void SigFunc(int);

extern char ProcessName[40], ProductDir[200], TmpDir[200];

void rtrim (char *instr);
char *ptr_ltrim (char *instr);
void change_logname (char *new_logname);
void change_loglvl (int new_lvl);
int create_daemon (void);
int app_mkpath (char *path);
int app_mkdir (char *dir_name);
int file_exists_time (char *file, long *mtime);
int dir_exists (char *dir);
long get_file_size (char *file);
void app_setup (char *argv0, char *registry_cfg_file);
void app_exit (int signum);
int ready_for_child (int max_children);
void increment_child_count (void);
void app_sigchld (int signum);
void check_buffer_size (char **buffer, int *blen, int new_slen);

unsigned short std_to_daynum (char *date_str);
void nap (unsigned long milli_sec);
READ_CFG_STS read_cfg_file (char *buf, int bufsz, char *label, char *filename);

int ignore_signals (void);
int restore_signals (void);

char *uuencode (unsigned char *bufin, int bufsz);
int uuencode_mem (unsigned char *bufin, int nbytes, char *outbuf);
int uudecode (char *bufcoded, unsigned char *outbuf, int outbufsize);

#ifdef	__cplusplus
}
#endif

#endif	/* APPUTIL_H */
