#ifndef XMLNEWS_META_H
#define XMLNEWS_META_H

#ifdef	__cplusplus
extern "C" {
#endif

#include "resource_id.h"
#include "xmlparse/xmlnews_meta_tags.h"
#ifdef NOWAVO
  #include "expat.h"
#else
  #include "expat/expat.h"
#endif


#define XMLNEWS_STOCK_DELIM_DEFAULT ':'

/* All time data in the XMLNEWS_META struct is returned in ISO format:
YYYY-MM-DDTHH:MM:SS-hh:mm where hh:mm is the offset from GMT.  For example,
2000-05-25T03:00:30-04:00 indicates 30 seconds after 3 am EDT on
May 25, 2000 */


typedef struct {
	XN_ELEMENT child;
	XN_ELEMENT classification;
	XN_ELEMENT companyCode;
	XN_ELEMENT companyName;
	XN_ELEMENT copyright;
	XN_ELEMENT creator;
	XN_ELEMENT dateline;
	char *description;
	char *distributionRights;
	XN_ELEMENT distributorCode;		/* rxg -- is this a string -- same question
									for other things like locationCode */
	XN_ELEMENT distributorName;
	XN_ELEMENT eventCode;
	XN_ELEMENT eventName;
    char expireTime[30];
	XN_ELEMENT fixtureCode;
	XN_ELEMENT fixtureName;
	XN_ELEMENT industryCode;
	XN_ELEMENT industryName;
	XN_ELEMENT language;
	XN_ELEMENT locationCode;
	XN_ELEMENT locationName;
    char nextVersion[RESOURCE_ID_LEN + 30];
	XN_ELEMENT parent;
	XN_ELEMENT personCode;
	XN_ELEMENT personName;
    char previousVersion[RESOURCE_ID_LEN + 30];
    int priority;
    int providerCode;
    char providerName[512];
    char publicationTime[30];
    char receivedTime[30];
    char releaseTime[30];
	XN_ELEMENT rendition;
    char resourceID[RESOURCE_ID_LEN + 30];
    int serviceCode;
    char serviceName[512];
	XN_ELEMENT sourceCode;		/* rxg -- can there really be more than one
								check www.xmlnews.org for others that should
								maybe be limited to one occurrance. Note
								soureName used to be one. */
    XN_ELEMENT sourceName;
	XN_ELEMENT subjectCode;
	XN_ELEMENT subjectName;
    char *title;
	XN_ELEMENT url;
	XN_ELEMENT vendorData;
} XMLNEWS_META;


/* rxg -- is 50 big enuf -- make match name in xmlnews_meta_tags.h */
typedef struct {
	XMLNEWS_META_TAG tag;
	char tag_name[50];
	char *tmpstr;
	int tlen;
	int curr_len;
} META_LEVEL_INFO;

typedef struct {
	int child;
	int classification;
	int companyCode;
	int companyName;
	int copyright;
	int creator;
	int dateline;
	int distributorCode;
	int distributorName;
	int eventCode;
	int eventName;
	int fixtureCode;
	int fixtureName;
	int industryCode;
	int industryName;
	int language;
	int locationCode;
	int locationName;
	int parent;
	int personCode;
	int personName;
	int rendition;
	int sourceCode;
	int sourceName;
	int subjectCode;
	int subjectName;
	int url;
	int vendorData;
} MUD_ALLOCS;

typedef struct {
	XMLNEWS_META xmlnews_meta;
	char filename[512];
	META_LEVEL_INFO x[MAX_XMLPARSE_LEVELS];
	int level;
	MUD_ALLOCS n;
} META_USER_DATA;


void xmlnews_meta_thread_init (void);

int xmlnews_parse_meta_r (META_USER_DATA *mud, XML_Parser *parser,
							char *filename, char *save_filename,
							char *buf, long buflen, int is_final_data);
XMLNEWS_META *xmlnews_parse_meta (char *filename, char *buf, long buflen,
									int is_final_data);

#ifdef	__cplusplus
}
#endif

#endif /** XMLNEWS_META_H **/
