#ifndef XMLNEWS_TABLE_H
#define XMLNEWS_TABLE_H

#ifdef	__cplusplus
extern "C" {
#endif


#define MAX_ROWS 2000
#define MAX_COLS 100

/* rxg -- make str dynamic use XN_DATA ?? */
typedef struct {
	char str[200];
	int colspan;
} XMLNEWS_TABLE_COLUMN;

typedef struct {
	XMLNEWS_TABLE_COLUMN column[MAX_COLS];
} XMLNEWS_TABLE_ROW;

typedef struct {
	int nrows;
	int ncols;
	char title[1000];
	XMLNEWS_TABLE_ROW row[MAX_ROWS];
	int width[MAX_COLS];
} XMLNEWS_TABLE;

typedef struct {
	char tag_name[50];
	char *tmpstr;
	int tlen;
	int curr_len;
} TABLE_LEVEL_INFO;

typedef struct {
	XMLNEWS_TABLE xmlnews_table;
	char filename[512];
	TABLE_LEVEL_INFO x[MAX_XMLPARSE_LEVELS];
	int level;
} TABLE_USER_DATA;


int xmlnews_parse_table_r (TABLE_USER_DATA *tud, XML_Parser *parser,
							char *filename, char *save_filename,
							char *buf, long buflen, int is_final_data);

XMLNEWS_TABLE *xmlnews_parse_table (char *filename, char *buf, long buflen,
									int is_final_data);

int xmlnews_extract_tables (char *buffer);
void xmlnews_insert_tables (char *buffer);


#ifdef	__cplusplus
}
#endif

#endif /** XMLNEWS_TABLE_H **/
