#ifndef XMLPARSE_H
#define XMLPARSE_H

#ifdef	__cplusplus
extern "C" {
#endif

typedef struct {
	char *str;
	int slen;
} XN_DATA;

typedef struct {
	int nvals;
	XN_DATA *xn_data;
} XN_ELEMENT;

/* Specify the maximum nesting level of XML tags. */
#define MAX_XMLPARSE_LEVELS 50

void reset_xn_element (XN_ELEMENT *xn_element, int *n_allocs);
int add_to_tmpstr (char **tmpstr, int *tlen, int *curr_len,
					char *new_data, int new_len);
int add_xn_element (XN_ELEMENT *xn_element, int *n_allocs, char *new_val);
int alloc_xn_data (XN_DATA **xn_data, int *n_allocs);
int copy_to_static (char *target, int target_size, char *new_val);
void copy_to_dynamic (char **target, char *new_val);
void xmlparse_free_buffer (char **str);
char *xmlparse_get_encoding (char *input);
void att_to_dynamic (const char **atts, char *name, char **target);
void att_to_xn_element (const char **atts, char *name,
                        XN_ELEMENT *xn_element, int *n_allocs);
void att_to_int (const char **atts, char *name, int *target);

typedef enum {
	META_TAG,
	STORY_TAG
} TAG_TYPE;
int is_keep_tag (TAG_TYPE tag_type, char *tag_name);

void restore_entities (char **input, int *input_alloc_len,
						int *curr_len, TAG_TYPE tag_type);

void unescape_via_expat_set_encoding (char *input_encoding);
char *unescape_via_expat (char *buffer);
char *extract_entities_via_expat (char *buffer);

/* call to check for wellformed xml in a buffer
*/
int is_valid_xml(const char *buffer ,int length);

#ifdef	__cplusplus
}
#endif

#endif	/* XMLPARSE_H */
